<script setup lang="ts">
import { reactive, onMounted, ref } from "vue";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { Modal } from "bootstrap";
import { useResourceStore } from "@/stores/resources";
import type { ResourceIn } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { Tooltip } from "bootstrap";

const resourceRepository = useResourceStore();

const resourceCreateForm = ref<HTMLFormElement | undefined>(undefined);
const resourceNameElement = ref<HTMLInputElement | undefined>(undefined);

const resource = reactive<ResourceIn>({
  name: "",
  description: "",
  release: "",
  source: "",
  private: true,
});

const formState = reactive<{
  validated: boolean;
  resourceNameTaken: boolean;
  loading: boolean;
}>({
  validated: false,
  resourceNameTaken: false,
  loading: false,
});

const props = defineProps<{
  modalId: string;
}>();

let createResourceModal: Modal | null = null;

function createResource() {
  formState.validated = true;
  formState.resourceNameTaken = false;
  resource.description = resource.description.trim();
  resource.name = resource.name.trim();
  resourceNameElement.value?.setCustomValidity("");
  if (resourceCreateForm.value?.checkValidity()) {
    formState.loading = true;
    resourceRepository
      .createResource(resource)
      .then(() => {
        createResourceModal?.hide();
        resource.name = "";
        resource.description = "";
        resource.source = "";
        resource.release = "";
        resource.private = true;
        formState.resourceNameTaken = false;
        formState.validated = false;
      })
      .catch((error) => {
        if (
          error.response?.status === 400 &&
          error.response?.data?.["detail"] ===
            `Resource with name '${resource.name}' already exists`
        ) {
          formState.resourceNameTaken = true;
          resourceNameElement.value?.setCustomValidity(
            "Resource name is already taken",
          );
        }
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

function modalClosed() {
  formState.validated = false;
  formState.resourceNameTaken = false;
  resourceNameElement.value?.setCustomValidity("");
}

onMounted(() => {
  createResourceModal = new Modal("#" + props.modalId);
  new Tooltip("#tooltip-new-resource-source");
  new Tooltip("#tooltip-new-resource-release");
  new Tooltip("#tooltip-new-resource-private");
});
</script>

<template>
  <bootstrap-modal
    :modal-id="modalId"
    static-backdrop
    modal-label="Create Resource Modal"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header> Create new Resource</template>
    <template #body>
      <form
        id="resourceCreateForm"
        ref="resourceCreateForm"
        :class="{ 'was-validated': formState.validated }"
      >
        <div class="mb-3">
          <label for="resourceNameInput" class="form-label"
            >Resource Name</label
          >
          <div class="input-group">
            <input
              id="resourceNameInput"
              ref="resourceNameElement"
              v-model="resource.name"
              type="text"
              class="form-control"
              required
              minlength="3"
              maxlength="32"
            />
            <div class="invalid-feedback">
              <div v-if="formState.resourceNameTaken">
                Resource name already taken.
              </div>
              <div>
                Requirements
                <ul>
                  <li>At least 3 Characters long</li>
                  <li>Unique in CloWM</li>
                </ul>
              </div>
            </div>
          </div>
        </div>
        <div class="mb-3">
          <label for="resourceDescriptionInput" class="form-label">
            Description
          </label>
          <div class="input-group">
            <textarea
              id="resourceDescriptionInput"
              v-model="resource.description"
              class="form-control"
              required
              rows="3"
              minlength="16"
              maxlength="256"
              placeholder="Describe the purpose of the resource"
            ></textarea>
            <div class="invalid-feedback">
              Requirements
              <ul>
                <li>At least 16 Characters long</li>
              </ul>
            </div>
          </div>
        </div>
        <div class="mb-3">
          <label for="resourceSourceInput" class="form-label"> Source </label>
          <div class="input-group">
            <div class="input-group-text">
              <font-awesome-icon icon="fa-solid fa-link" />
            </div>
            <input
              id="resourceSourceInput"
              v-model="resource.source"
              class="form-control"
              required
              minlength="8"
              maxlength="264"
              placeholder="The source of the resource (e.g. a link)"
            />
            <div
              id="tooltip-new-resource-source"
              class="input-group-text hover-info"
              data-bs-toggle="tooltip"
              data-bs-title="The source from where the resource comes"
            >
              <font-awesome-icon icon="fa-solid fa-circle-question" />
            </div>
          </div>
        </div>
        <div class="mb-3">
          <label for="resourceReleaseInput" class="form-label"> Release </label>
          <div class="input-group">
            <div class="input-group-text">
              <font-awesome-icon icon="fa-solid fa-tag" />
            </div>
            <input
              id="resourceReleaseInput"
              v-model="resource.release"
              class="form-control"
              required
              minlength="3"
              maxlength="32"
              placeholder="Initial release name"
            />
            <div
              id="tooltip-new-resource-release"
              class="input-group-text hover-info"
              data-bs-toggle="tooltip"
              data-bs-title="The name of the first resource version"
            >
              <font-awesome-icon icon="fa-solid fa-circle-question" />
            </div>
          </div>
        </div>
        <div class="mb-3">
          <div class="form-check fs-5">
            <input
              id="resourcePrivateInput"
              v-model="resource.private"
              class="form-check-input"
              type="checkbox"
              :true-value="false"
              :false-value="true"
            />
            <label
              id="tooltip-new-resource-private"
              class="form-check-label"
              for="resourcePrivateInput"
              data-bs-toggle="tooltip"
              data-bs-placement="bottom"
              data-bs-title="Flag if the resource should should be used by other workflow developer"
            >
              Public Resource
            </label>
          </div>
        </div>
      </form>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        type="submit"
        form="resourceCreateForm"
        class="btn btn-primary"
        :disabled="formState.loading"
        @click.prevent="createResource"
      >
        <span
          v-if="formState.loading"
          class="spinner-border spinner-border-sm"
          role="status"
          aria-hidden="true"
        ></span>
        Save
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
